import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/fetchData/makeCacheItem.ts";
import { OT, pipe, T } from '@contentlayer/utils/effect';
import { getComputedValues } from './getComputedValues.js';
import { makeDocument } from './makeDocument.js';
export const makeCacheItem = ({ databaseTypeDef, documentTypeDef, previousCache, page, options }) => (OT.withSpan('@contentlayer/source-notion/fetchData:makeCacheItem')(T.gen(function* ($) {
    const documentHash = new Date(page.last_edited_time).getTime().toString();
    if (previousCache &&
        previousCache.cacheItemsMap[page.id] &&
        previousCache.cacheItemsMap[page.id].documentHash === documentHash &&
        previousCache.cacheItemsMap[page.id].hasWarnings === false) {
        const cacheItem = previousCache.cacheItemsMap[page.id];
        return cacheItem;
    }
    const document = yield* $(makeDocument({ documentTypeDef, databaseTypeDef, page, options }), fileName_1 + ":33:32");
    const computedValues = yield* $(getComputedValues({ document, documentTypeDef }), fileName_1 + ":34:38");
    Object.entries(computedValues).forEach(([fieldName, value]) => {
        document[fieldName] = value;
    });
    return {
        document,
        documentHash,
        hasWarnings: false,
        documentTypeName: documentTypeDef.name,
    };
}, fileName_1 + ":20:10")));
//# sourceMappingURL=makeCacheItem.js.map