import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/index.ts";
import { processArgs } from '@contentlayer/core';
import { pipe, S, T } from '@contentlayer/utils/effect';
import { NotionRenderer } from '@notion-render/client';
import * as notion from '@notionhq/client';
import { fetchData } from './fetchData/fetchData.js';
import { fetchNotion } from './notion/fetchNotion.js';
import { provideSchema } from './schema/provideSchema.js';
import { flattendDatabaseTypeDef } from './schema/utils/flattenDatabaseTypeDef.js';
import { NotionClient, NotionRenderer as NotionRendererTag } from './services.js';
export * from './schema/types/database.js';
export const makeSource = async (args) => {
    const { options, extensions, restArgs: { databaseTypes, ...rest }, } = await processArgs(args);
    const databaseTypeDefs = (Array.isArray(databaseTypes) ? databaseTypes : Object.values(databaseTypes)).map((_) => _.def());
    const client = rest.client instanceof notion.Client
        ? rest.client
        : new notion.Client({
            fetch: fetchNotion,
            ...rest.client,
        });
    const renderer = rest.renderer instanceof NotionRenderer ? rest.renderer : new NotionRenderer({ client, ...rest.renderer });
    return {
        type: 'notion',
        extensions,
        options,
        provideSchema: () => (T.provideService(NotionRendererTag)(renderer, fileName_1 + ":46:44")(T.provideService(NotionClient)(client, fileName_1 + ":45:39")(provideSchema({ databaseTypeDefs, options })))),
        fetchData: ({ schemaDef }) => (S.fromEffect((T.provideService(NotionRendererTag)(renderer, fileName_1 + ":59:48")(T.provideService(NotionClient)(client, fileName_1 + ":58:43")(T.either(fetchData({
            databaseTypeDefs: databaseTypeDefs.map((databaseTypeDef) => flattendDatabaseTypeDef(databaseTypeDef)),
            schemaDef,
            options,
        }), fileName_1 + ":57:21")))))),
    };
};
//# sourceMappingURL=index.js.map